<script lang="ts">
	import List, { Item, Separator, Subheader } from '@smui/list';
	import ScheduleEvent from './ScheduleEvent.svelte';
	import mapData from "../Map/map.json"
	import { onMount } from 'svelte';
	import type { Schedule, Event } from './domain/ScheduleDomain';
	import { ZonedDateTime } from '@js-joda/core';
	import { featureToggles } from '$lib/featureToggles';
	export let schedule: Schedule;

	export let nowFn: () => ZonedDateTime = () => ZonedDateTime.now();
	export let now: ZonedDateTime = nowFn();

	export let updateInterval: number = 60 * 1000;
	onMount(() => {
		const ret = window.setInterval(() => {
			now = nowFn();
		}, updateInterval);
		return () => window.clearInterval(ret);
	});

	export let onClickScheduleEvent: (location: string) => void | undefined;


	let knownLocationNames: string[] = mapData.features.map((feature) => feature.properties.name);
	$: knownLocationNames;

	let nextEventsGroupedByRoom: ([Event] | [Event, Event])[];
	$: nextEventsGroupedByRoom = schedule.currentAndUpToOneFutureEventPerRoom(now);
</script>

<List threeLine>
	{#each nextEventsGroupedByRoom as eventsInRoom}
		<Subheader style="font-weight: bold">{eventsInRoom[0].location}</Subheader>
		{#if $featureToggles['fix-room-selection-for-unknowns']}
		{#if knownLocationNames.find(x => x == eventsInRoom[0].location)}
		<Item
			class="three-line-item"
			role="button"
			aria-label={eventsInRoom[0].location}
			on:click={() => onClickScheduleEvent?.call(null, eventsInRoom[0].location)}
		>
			{#each eventsInRoom as event}
				<ScheduleEvent {event} {now} />
			{/each}
		</Item>
		{:else}
		<Item
			nonInteractive
			class="three-line-item"
			aria-label={eventsInRoom[0].location}
		>
			{#each eventsInRoom as event}
				<ScheduleEvent {event} {now} />
			{/each}
		</Item>
		{/if}
		{:else}
		<Item
			class="three-line-item"
			role="button"
			aria-label={eventsInRoom[0].location}
			on:click={() => onClickScheduleEvent?.call(null, eventsInRoom[0].location)}
		>
			{#each eventsInRoom as event}
				<ScheduleEvent {event} {now} />
			{/each}
		</Item>
		{/if}
		<Separator />
	{/each}
</List>

<style lang="scss">
	:global(.three-line-item) {
		height: 88px !important;
		display: flex;
		flex-direction: row;
	}
	:global(.three-line-item > span) {
		flex: 1;
	}
</style>
